<script setup>
import {useRoute} from "vue-router"
import {computed, ref, watch} from "vue"
import {useTrainerStore} from "@/stores/trainer";
import Sidebar from "@/components/Sidebar.vue"
import {router} from "@/router";
import {useEnumStore} from "@/stores/enumStore";

const route = useRoute()
const trainerStore = useTrainerStore()

const trainerIndex = computed(() => parseInt(route.params.trainerIndex))
const trainerget = computed(() => trainerStore.trainers[trainerIndex.value])

const trainer = ref()

const enumStore = useEnumStore()
const trainerFirstName = ref("")
const trainerLastName = ref("")
const trainerEmail = ref("")
const trainerCity = ref("")
const trainerSalary = ref("")
const trainerEmployment = ref("")
const trainerSubject = ref([])
const edit = ref(false)

const apiError = ref("")
watch(trainerget, () => trainer.value = ({...trainerget.value} || {firstName: ""}), {immediate: true})

async function deleteTrainer() {
  const response = await useTrainerStore().deleteTrainer(trainer.value);

  await router.push("/trainer")
  console.log("test");
}

async function updateTrainer() {

  apiError.value = ""

  try {
    await trainerStore.updateTrainer({
      firstName: trainer.value.firstName,
      lastName: trainer.value.lastName,
      email: trainer.value.email,
      residence: trainer.value.residence,
      salary: trainer.value.salary,
      employmentType: trainer.value.employmentType,
      subjects: trainer.value.subjects,
      id: trainer.value.id

    })

  } catch (err) {
    if (err.isAxiosError && err.status === 401) {
      apiError.value = "You must be logged in"
    } else {
      apiError.value = "Unknown error"
    }
  }
  await router.push("/trainer")

  trainerFirstName.value = ""
  trainerLastName.value = ""
  trainerEmail.value = ""
  trainerCity.value = ""
  trainerSalary.value = ""
  trainerEmployment.value = ""
  trainerSubject.value = []
}


</script>

<template>
  <Sidebar></Sidebar>

  <h1>Details for Trainers</h1>

  <div class="container text-white rounded-2 p-3 mb-3">
    <p>First Name: <span v-if="!edit">{{ trainer.firstName }}</span> <input v-else type="text" class="form-control"
                                                                            v-model="trainer.firstName"/></p>
    <p>Last Name: <span v-if="!edit">{{ trainer.lastName }}</span> <input v-else type="text" class="form-control"
                                                                          v-model="trainer.lastName"/></p>
    <p>Email: <span v-if="!edit">{{ trainer.email }}</span> <input v-else type="text" class="form-control"
                                                                   v-model="trainer.email"/></p>
    <p>City: <span v-if="!edit">{{ trainer.residence }}</span> <input v-else type="text" class="form-control"
                                                                      v-model="trainer.residence"/></p>
    <p>Gross Salary: <span v-if="!edit">{{ trainer.salary }}</span> <input v-else type="text" class="form-control"
                                                                           v-model="trainer.salary"/></p>
    <p>Net Salary: {{ trainer.salary * 0.8 }}</p>
    <p>Employment Type: <span v-if="!edit">{{ trainer.employmentType }}</span>
      <select v-else class="form-select" v-model="trainer.employmentType">
        <option v-for="emp in enumStore.employmentTypes">{{ emp }}</option>
      </select></p>

    <p>Subjects:</p>
    <p v-if="!edit" v-for="subjects in trainer.subjects">{{ subjects + " " }}</p>
    <fieldset v-else>
      <div class="form-check" v-for="subjects in enumStore.subjects">
        <input type="checkbox" class="form-check-input" v-model="trainer.subjects" :value="subjects">
        <label class="form-check-label" for="check1">{{ subjects }}</label>
      </div>
    </fieldset>
  </div>

  <div class="buttons">
    <v-btn type="submit" class="btn btn-warning mx-2" @click="edit = !edit" v-if="!edit">Edit</v-btn>
    <v-btn type="submit" class="btn btn-warning mx-2" @click="updateTrainer" v-else>Save</v-btn>
    <v-btn type="submit" class="btn btn-danger" @click="deleteTrainer">Delete</v-btn>
  </div>


</template>

<style scoped>
h1 {
  margin-left: 0px;
  margin-bottom: 20px;
  margin-top: 0px;
}

p {
  margin-left: 0px;
}

.form-check {
  margin-left: 0px;
}

.container {
  background-color: black;
  width: 1000px;
}

.buttons {
  margin-left: 0px;
  margin-top: 15px;
  margin-bottom: 20px;

}


</style>